## proxmox-widget-toolkit 4.3.2

=== Makefile ===
include defines.mk

ESLINT ?= $(if $(shell command -v pve-eslint), pve-eslint, eslint)

SUBDIRS= css images proxmox-dark

# bundle it for now from the libjs-marked debian package to avoid touching our proxies file mapper,
# we could also just ship a link to the packages file and load from same path as the widget-toolkit
MARKEDJS=/usr/share/javascript/marked/marked.js

JSSRC=					\
	Utils.js			\
	Schema.js			\
	Toolkit.js			\
	Logo.js				\
	Parser.js			\
	mixin/CBind.js			\
	data/reader/JsonObject.js	\
	data/ProxmoxProxy.js		\
	data/UpdateStore.js		\
	data/DiffStore.js		\
	data/ObjectStore.js		\
	data/RRDStore.js		\
	data/TimezoneStore.js		\
	data/model/NotificationConfig.js	\
	data/model/Realm.js		\
	data/model/Certificates.js	\
	data/model/ACME.js		\
	form/BandwidthSelector.js	\
	form/DisplayEdit.js		\
	form/ExpireDate.js		\
	form/IntegerField.js		\
	form/TextField.js		\
	form/TextAreaField.js		\
	form/VlanField.js		\
	form/DateTimeField.js		\
	form/Checkbox.js		\
	form/KVComboBox.js		\
	form/LanguageSelector.js	\
	form/ComboGrid.js		\
	form/RRDTypeSelector.js		\
	form/BondModeSelector.js	\
	form/NetworkSelector.js		\
	form/RealmComboBox.js		\
	form/PruneKeepField.js		\
	form/RoleSelector.js		\
	form/DiskSelector.js		\
	form/MultiDiskSelector.js	\
	form/TaskTypeSelector.js	\
	form/ACME.js			\
	form/UserSelector.js		\
	form/ThemeSelector.js		\
	button/Button.js		\
	button/AltText.js		\
	button/HelpButton.js		\
	grid/ObjectGrid.js		\
	grid/PendingObjectGrid.js	\
	panel/AuthView.js		\
	panel/DiskList.js		\
	panel/EOLNotice.js		\
	panel/InputPanel.js		\
	panel/InfoWidget.js		\
	panel/LogView.js		\
	panel/NodeInfoRepoStatus.js	\
	panel/NotificationConfigView.js	\
	panel/JournalView.js		\
	panel/PermissionView.js		\
	panel/PruneKeepPanel.js		\
	panel/RRDChart.js		\
	panel/GaugeWidget.js		\
	panel/GotifyEditPanel.js	\
	panel/Certificates.js		\
	panel/ACMEAccount.js		\
	panel/ACMEPlugin.js		\
	panel/ACMEDomains.js		\
	panel/EmailRecipientPanel.js	\
	panel/SendmailEditPanel.js	\
	panel/SmtpEditPanel.js	\
	panel/StatusView.js		\
	panel/TfaView.js		\
	panel/NotesView.js		\
	panel/WebhookEditPanel.js	\
	window/Edit.js			\
	window/PasswordEdit.js		\
	window/SafeDestroy.js		\
	window/PackageVersions.js	\
	window/TaskViewer.js		\
	window/LanguageEdit.js		\
	window/DiskSmart.js		\
	window/ZFSDetail.js		\
	window/Certificates.js		\
	window/ConsentModal.js		\
	window/ACMEAccount.js		\
	window/ACMEPluginEdit.js	\
	window/ACMEDomains.js		\
	window/EndpointEditBase.js	\
	window/NotificationMatcherEdit.js \
	window/FileBrowser.js		\
	window/AuthEditBase.js		\
	window/AuthEditOpenId.js	\
	window/AuthEditLDAP.js		\
	window/AuthEditAD.js		\
	window/AuthEditSimple.js        \
	window/TfaWindow.js		\
	window/AddTfaRecovery.js	\
	window/AddTotp.js		\
	window/AddWebauthn.js		\
	window/AddYubico.js		\
	window/TfaEdit.js		\
	window/NotesEdit.js		\
	window/ThemeEdit.js		\
	window/SyncWindow.js	\
	node/APT.js			\
	node/APTRepositories.js		\
	node/NetworkEdit.js		\
	node/NetworkView.js		\
	node/DNSEdit.js			\
	node/HostsView.js		\
	node/DNSView.js			\
	node/Tasks.js			\
	node/ServiceView.js		\
	node/TimeEdit.js		\
	node/TimeView.js

all: $(SUBDIRS)
	set -e && for i in $(SUBDIRS); do $(MAKE) -C $$i; done

.lint-incremental: $(JSSRC)
	$(ESLINT) $?
	touch "$@"

.PHONY: lint
check: lint
	$(ESLINT) --strict api-viewer/APIViewer.js
lint: $(JSSRC)
	$(ESLINT) --strict $(JSSRC)
	touch ".lint-incremental"

BUILD_TIME=$(or $(SOURCE_DATE_EPOCH),$(shell date '+%s.%N'))
BUILD_VERSION=$(or $(DEB_VERSION),$(shell git rev-parse HEAD),unknown version)
proxmoxlib.js: .lint-incremental $(JSSRC)
	# add the version as comment in the file
	echo "// v$(BUILD_VERSION)-t$(BUILD_TIME)" > $@.tmp
	cat $(JSSRC) $(MARKEDJS)  >> $@.tmp
	mv $@.tmp $@

proxmoxlib.min.js: proxmoxlib.js
	uglifyjs $< -c -m -o $@.tmp
	mv $@.tmp $@

install: proxmoxlib.js proxmoxlib.min.js
	install -d -m 755 $(WWWBASEDIR)
	install -m 0644 proxmoxlib.js proxmoxlib.min.js $(WWWBASEDIR)
	set -e && for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done

.PHONY: clean
clean:
	$(MAKE) -C proxmox-dark $@
	rm -f proxmoxlib.js* proxmoxlib.min.js* .lint-incremental

=== css/Makefile ===
include ../defines.mk

CSS=ext6-pmx.css

all:

.PHONY: install
install: $(CSS)
	install -d $(WWWCSSDIR)
	for i in $(CSS); do install -m 0644 $$i $(WWWCSSDIR)/$$i; done

.PHONY: clean
clean:

=== images/Makefile ===
include ../defines.mk

IMAGES=pmx-clear-trigger.png		\
       openid-icon-100x100.png		\
       icon-cpu.svg			\
       icon-ram.svg			\
       debian-swirl-openlogo.svg	\
       proxmox-symbol-x.svg		\

all:

.PHONY: install
install: $(IMAGES)
	install -d $(WWWIMAGESDIR)
	for i in $(IMAGES); do install -m 0644 $$i $(WWWIMAGESDIR)/$$i; done

.PHONY: clean
clean:

=== proxmox-dark/Makefile ===
include ../defines.mk

SCSSSRC=scss/ProxmoxDark.scss 			\
	scss/abstracts/_mixins.scss 		\
	scss/abstracts/_variables.scss 		\
	scss/extjs/_body.scss 			\
	scss/extjs/form/_button.scss 		\
	scss/extjs/form/_combobox.scss 		\
	scss/extjs/form/_formfield.scss 	\
	scss/extjs/_grid.scss 			\
	scss/extjs/_menu.scss 			\
	scss/extjs/_panel.scss 			\
	scss/extjs/_presentation.scss 		\
	scss/extjs/_progress.scss 		\
	scss/extjs/_splitter.scss 		\
	scss/extjs/_tabbar.scss 		\
	scss/extjs/_tip.scss 			\
	scss/extjs/_toolbar.scss 		\
	scss/extjs/_treepanel.scss 		\
	scss/extjs/_window.scss 		\
	scss/other/_charts.scss 		\
	scss/other/_icons.scss 			\
	scss/proxmox/_general.scss 		\
	scss/proxmox/_helpbutton.scss 		\
	scss/proxmox/_loadingindicator.scss	\
	scss/proxmox/_markdown.scss 		\
	scss/proxmox/_nodes.scss 		\
	scss/proxmox/_quarantine.scss 		\
	scss/proxmox/_storages.scss 		\
	scss/proxmox/_tags.scss 		\
	scss/proxmox/_datepicker.scss

.PHONY: all
all: theme-proxmox-dark.css

.PHONY: install
install: theme-proxmox-dark.css
	install -d $(WWWTHEMEDIR)/
	install -m 0664 theme-proxmox-dark.css $(WWWTHEMEDIR)/

theme-proxmox-dark.css: $(SCSSSRC)
	sassc -t compressed $< $@.tmp
	mv $@.tmp $@

.PHONY: clean
clean:
	rm -rf theme-proxmox-dark.css

=== debian/changelog ===
proxmox-widget-toolkit (4.3.2) bookworm; urgency=medium

  * node: service state: restore original behavior

  * window: add consent modal widget

  * object grid: add support for multiline textarea widget

 -- Proxmox Support Team <support@proxmox.com>  Mon, 25 Nov 2024 18:32:21 +0100

proxmox-widget-toolkit (4.3.1) bookworm; urgency=medium

  * peraration to fix #5379: panel: authentication realm view: add opt-in
    column displaying whether the realm is default and allow enabling it for a
    realm

  * various UX improvements for the webhook edit window:
    - improve layout and component hierarchy
    - use type in add button text
    - show empty-text to key-value fields
    - display validity for added key/value fields immediately

  * add Bulgarian as available language

  * dark theme: make icons in the permissions tree in Proxmox VE UI dark

  * fix #3892: network: add bridge VIDs field for Linux bridge and enable them
    if VLAN-aware is enabled.

 -- Proxmox Support Team <support@proxmox.com>  Tue, 19 Nov 2024 12:40:04 +0100

proxmox-widget-toolkit (4.3.0) bookworm; urgency=medium

  * css: add some conditions to the tag classes for the tag view

  * utils: add base64 conversion helper

  * notification: add UI for adding/updating webhook targets

  * fix #5836: ui: translate systemd states in system service view

  * fix #5611: node service view: hide non-installed system services by
    default

  * password edit: allow one to override the minimum length parameter

  * fix #5831: ui: right-align s.m.a.r.t numerical table data

 -- Proxmox Support Team <support@proxmox.com>  Mon, 11 Nov 2024 21:57:31 +0100

proxmox-widget-toolkit (4.2.4) bookworm; urgency=medium

  * notification: matcher: match-field: show known fields/values

  * notification: matcher: move match-severity and match-calendar fields to
    panel

  * css: dark theme: fix panel borders for the Proxmox Mail Gateway's EOL
    notice widget

  * fix opening a link from another site to a web UI of our products by
    setting the auth-cookie's 'SameSite' attribute to lax, which is the safe
    default in modern browsers.

 -- Proxmox Support Team <support@proxmox.com>  Wed, 16 Oct 2024 18:54:37 +0200

proxmox-widget-toolkit (4.2.3) bookworm; urgency=medium

  * realm edit: don't send type as extra parameter when 'useTypeInUrl' is set

  * realm edit: don't send 'delete' parameter when creating new entry

 -- Proxmox Support Team <support@proxmox.com>  Thu, 25 Apr 2024 11:45:12 +0200

proxmox-widget-toolkit (4.2.2) bookworm; urgency=medium

  * form: move network VLAN field widget over from PVE

 -- Proxmox Support Team <support@proxmox.com>  Wed, 24 Apr 2024 21:44:12 +0200

proxmox-widget-toolkit (4.2.1) bookworm; urgency=medium

  * fix #5251: tfa: set one-time-code auto-complete hint on TOTP input field

  * sendmail: smtp: allow one to override the default mail author

 -- Proxmox Support Team <support@proxmox.com>  Tue, 23 Apr 2024 19:25:06 +0200

proxmox-widget-toolkit (4.2.0) bookworm; urgency=medium

  * window: add widget for Active Directory specific LDAP-like authentication

  * window: ldap: add tooltips for firstname, lastname and email attributes

  * dark-mode: set intentionally black icons to `$icon-color`

  * window: edit: avoid sharing custom config objects between subclasses

  * i18n: make various user-facing strings translatable

  * remove button: allow one to set custom confirmation message

  * notify: change 'Remove' button to 'Reset' for built-in targets

  * css: correctly mask disabled elements inside headers

  * fix #5277: move reset button into window header toolbar. The form reset
    and the form submit button where located besides each other with the exact
    same styling. This made it easy to click the wrong one by accident, while
    most of the time not a huge issue, it's quite annoying and just
    unnecessary to do it this way. Moving the reset functionality into the
    header, besides the close tool, avoid this potential mis-click and makes
    the form simpler in general. Mis-clicks between the close and the reset
    tool in the header are not an issue because they both have the same level
    of destructiveness w.r.t. pending data. Using the font-awesome undo icon
    makes it quite clear and a tooltip, which is also exposed as ARIA label,
    helps to further improve accessibility.

  * notes view:
    - place collapse tool on the right
    - use pencil-square-o icon for opening the editor
    - make opening the editor on double-click opt-in to avoid interfering with
      word-boundary selection of text by default.

  * network edit: allow bridges to have any valid interface name

 -- Proxmox Support Team <support@proxmox.com>  Sun, 21 Apr 2024 12:31:26 +0200

proxmox-widget-toolkit (4.1.5) bookworm; urgency=medium

  * dns: provide option to change behavior from sending the new, full actual
    state to what actually changed. This fixes deleting entries in APIs like
    the one from PBS.

  * edit window: add optional custom submit options

  * certificates: removal prompt: don't display name if there is no name

  * utils: api request: defer masking after layout

  * window: password edit: add opt-in config to show a confirmation-password
    field for the current user

  * window: password edit: clarify labels

 -- Proxmox Support Team <support@proxmox.com>  Thu, 21 Mar 2024 17:40:54 +0100

proxmox-widget-toolkit (4.1.4) bookworm; urgency=medium

  * fix #5074: notify: sendmail smtp: fix mailto/mailto-user parameter
    deletion

  * i18n: use correct ISO 639-1 code for Korean with backward compat

  * form: date time: fix changing date to end of month from a longer to a
    shorter month

  * form: combo grid: allow one to force showing a clear trigger through a new
    showClearTrigger config value

  * utils: add mechanism to add and override translatable notification event
    descriptions in the product specific UIs



=== debian/control ===
Source: proxmox-widget-toolkit
Section: web
Priority: optional
Maintainer: Proxmox Support Team <support@proxmox.com>
Build-Depends: debhelper-compat (= 13),
               libjs-marked,
               pve-eslint (>= 7.28.0),
               sassc,
               uglifyjs,
Standards-Version: 4.6.2
Homepage: https://www.proxmox.com

Package: proxmox-widget-toolkit
Architecture: all
Depends: ${misc:Depends}
Description: Core Widgets and ExtJS Helper Classes for Proxmox Web UIs
 The base framework providing widgets, models, and general utilities for the
 ExtJS based Web UIs of various Proxmox projects

Package: proxmox-widget-toolkit-dev
Architecture: all
Depends: ${misc:Depends}
Description: ExtJS based widgets and utilities for development
 Contains some common JavaScript code that some Proxmox projects might used to
 build common interfaces, like the API viewer in each documnetation repo.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_SOURCE
export DEB_VERSION

%:
	dh $@
